\documentclass{standalone}

\input{../../macros/macros}

\usepackage{../../../msc}

\begin{document}

\begin{msc}[msc keyword=, draw frame = none, instance distance=4cm,head top distance=0cm, foot distance=0cm]{}
\declinst{p}{}{A}
\declinst{v}{}{B}
\action*{nonce $a, n_a, k_a$}{p}
\action*{nonce $b, n_b, k_b$}{v}
\nextlevel[2]
\mess{$\pair{A}{g^a}$}{p}{v}
\nextlevel[1.5]
\mess{$\pair{B}{g^b}$}{v}{p}
\nextlevel[1]
\action*{$k = (g^b)^a$}{p}
\action*{$k = (g^a)^b$}{v}
\nextlevel[2]
\mess*{$n_a$}{p}{v}
\measure[l]{max $\Delta$}{p}{p}[2]
\nextlevel[1.5]
\mess*{$n_a \xor \enc{\hashFunc(B, k)}{k_b}$}{v}{p}
\nextlevel[1.5]
\mess*{$n_b$}{v}{p}
\measure[r]{max $\Delta$}{v}{v}[2]
\nextlevel[1.5]
\mess*{$n_b \xor \enc{\hashFunc(A, k)}{k_a}$}{p}{v}
\nextlevel[1.5]
\mess{$k_a$}{p}{v}
\nextlevel[1.5]
\mess{$k_b$}{v}{p}
\nextlevel[1]
\condition*{$k$ is secret}{v}
\condition*{$k$ is secret}{p}
\nextlevel[1.5]
\condition*{$B$ is communicating with $A$}{v}
\condition*{$A$ is communicating with $B$}{p}
\nextlevel[1]
\end{msc}

\end{document}